Index: trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 728)
@@ -8,7 +8,8 @@
  
       use radinc_h, only : L_NSPECTI,L_NSPECTV,naerkind
-      use watercommon_h, only : RLVTT
+      use watercommon_h, only : RLVTT, Psat_water
       use gases_h
       use radcommon_h, only: sigma
+      use radii_mod, only: h2o_reffrad, co2_reffrad
       use aerosol_mod
       implicit none
@@ -191,5 +192,5 @@
 
       character*80 fichier 
-      integer l,ig,ierr,iq,i, tapphys,nw
+      integer l,ig,ierr,iq,iaer
 
       real fluxsurf_lw(ngridmx)      ! incident LW (IR) surface flux (W.m-2)
@@ -213,6 +214,4 @@
       real zzlev(ngridmx,nlayermx+1) ! altitude at layer boundaries
       real latvl1,lonvl1             ! Viking Lander 1 point (for diagnostic)
-
-      real,save :: reffrad(ngridmx,nlayermx,naerkind) ! aerosol effective radius (m)
 
 !     Tendencies due to various processes:
@@ -231,13 +230,20 @@
       real zdhadj(ngridmx,nlayermx)                           ! (K/s)
       real zdtgw(ngridmx,nlayermx)                            ! (K/s)
+      real zdtmr(ngridmx,nlayermx)
       real zdugw(ngridmx,nlayermx),zdvgw(ngridmx,nlayermx)    ! (m.s-2)
       real zdtc(ngridmx,nlayermx),zdtsurfc(ngridmx)
       real zdvc(ngridmx,nlayermx),zduc(ngridmx,nlayermx)
+      real zdumr(ngridmx,nlayermx),zdvmr(ngridmx,nlayermx)
+      real zdtsurfmr(ngridmx)
+      
+      real zdmassmr(ngridmx,nlayermx),zdpsrfmr(ngridmx)
 
       real zdqdif(ngridmx,nlayermx,nqmx), zdqsdif(ngridmx,nqmx)
+      real zdqevap(ngridmx,nlayermx)
       real zdqsed(ngridmx,nlayermx,nqmx), zdqssed(ngridmx,nqmx)
       real zdqdev(ngridmx,nlayermx,nqmx), zdqsdev(ngridmx,nqmx)
       real zdqadj(ngridmx,nlayermx,nqmx)
       real zdqc(ngridmx,nlayermx,nqmx)
+      real zdqmr(ngridmx,nlayermx,nqmx),zdqsurfmr(ngridmx,nqmx)
       real zdqlscale(ngridmx,nlayermx,nqmx)
       real zdqslscale(ngridmx,nqmx)
@@ -329,6 +335,6 @@
       real qevap(ngridmx,nlayermx,nqmx)
       real tevap(ngridmx,nlayermx)
-      real dqevap(ngridmx,nlayermx)
-      real dtevap(ngridmx,nlayermx)
+      real dqevap1(ngridmx,nlayermx)
+      real dtevap1(ngridmx,nlayermx)
 
 !     included by BC for hydrology
@@ -343,5 +349,5 @@
 
 !     included by RW for RH diagnostic
-      real qsat(ngridmx,nlayermx), RH(ngridmx,nlayermx), H2Omaxcol(ngridmx)
+      real qsat(ngridmx,nlayermx), RH(ngridmx,nlayermx), H2Omaxcol(ngridmx),psat_tmp
 
 !     included by RW for hydrology
@@ -366,6 +372,6 @@
 
 !     included by BC for cloud fraction computations
-      real cloudfrac(ngridmx,nlayermx)
-      real totcloudfrac(ngridmx)
+      real,save :: cloudfrac(ngridmx,nlayermx)
+      real,save :: totcloudfrac(ngridmx)
 
 !     included by RW for vdifc water conservation test
@@ -389,18 +395,20 @@
 
 !     included by RW for variable H2O particle sizes
+      real,save :: reffrad(ngridmx,nlayermx,naerkind) ! aerosol effective radius (m)
+      real :: reffrad1(ngridmx,nlayermx,naerkind) ! for clearsky call to callcorrk
+      real,save :: nueffrad(ngridmx,nlayermx,naerkind) ! aerosol effective radius variance
+      real :: reffh2oliq(ngridmx,nlayermx) ! liquid water particles effective radius (m)
+      real :: reffh2oice(ngridmx,nlayermx) ! water ice particles effective radius (m)
       real reffH2O(ngridmx,nlayermx)
       real reffcol(ngridmx,naerkind)
 
 !     included by RW for sourceevol
-      real ice_initial(ngridmx)!, isoil
+      real, save :: ice_initial(ngridmx)!, isoil
       real delta_ice,ice_tot
-      real ice_min(ngridmx)
-      save ice_min
-      save ice_initial
-
+      real, save :: ice_min(ngridmx)
+      
       integer num_run
-      logical ice_update
-      save ice_update
-
+      logical,save :: ice_update
+      
 !=======================================================================
       
@@ -457,7 +465,5 @@
          call iniorbit(apoastr,periastr,year_day,peri_day,obliquit)
 
-         do ig=1,ngrid
-            albedo(ig)=albedo0(ig)
-         enddo
+         albedo(:)=albedo0(:)
 
          if(tlocked)then
@@ -473,11 +479,9 @@
          else
             print*,'WARNING! Thermal conduction in the soil turned off'
-            do ig=1,ngrid
-               capcal(ig)=1.e6
-               fluxgrd(ig)=0.
-               if(noradsurf)then
-                  fluxgrd(ig)=10.0
-               endif
-            enddo
+            capcal(:)=1.e6
+            fluxgrd(:)=0.
+            if(noradsurf)then
+                  fluxgrd(:)=10.0
+            endif
             print*,'Flux from ground = ',fluxgrd,' W m^-2'
          endif
@@ -502,7 +506,6 @@
 !        define surface as continent or ocean
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+         rnat(:)=1
          do ig=1,ngridmx
-            rnat(ig)=1
-
 !            if(iceball.or.oceanball.or.(inertiedat(ig,1).gt.1.E4))then
             if(inertiedat(ig,1).gt.1.E4)then
@@ -517,9 +520,5 @@
 !        initialise surface history variable 
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-         do ig=1,ngridmx
-            do iq=1,nqmx
-               qsurf_hist(ig,iq)=qsurf(ig,iq)
-            enddo
-         enddo
+         qsurf_hist(:,:)=qsurf(:,:)
 
 !        initialise variable for dynamical heating diagnostic
@@ -556,11 +555,7 @@
             endif
 
-            do ig=1,ngrid
-!already done above (JL12)
-!               qsurf_hist(ig,igcm_h2o_vap) = qsurf(ig,igcm_h2o_vap)
-               if(ice_update)then
-                  ice_initial(ig)=qsurf(ig,igcm_h2o_ice)
-               endif
-            enddo
+            if(ice_update)then
+               ice_initial(:)=qsurf(:,igcm_h2o_ice)
+            endif
 
          endif
@@ -585,15 +580,14 @@
 !     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-      pdu(:,:) = 0.0
-      pdv(:,:) = 0.0
-!      if ( (.not.nearco2cond).and.(.not.firstcall) ) then
+      pdu(1:ngridmx,1:nlayermx) = 0.0
+      pdv(1:ngridmx,1:nlayermx) = 0.0
       if ( .not.nearco2cond ) then
-         pdt(:,:) = 0.0
-      endif ! this was the source of an evil bug...
-      pdq(:,:,:)  = 0.0
-      pdpsrf(:)   = 0.0
-      zflubid(:)  = 0.0
-      zdtsurf(:)  = 0.0
-      dqsurf(:,:) = 0.0
+         pdt(1:ngridmx,1:nlayermx) = 0.0
+      endif
+      pdq(1:ngridmx,1:nlayermx,1:nqmx) = 0.0
+      pdpsrf(1:ngridmx)       = 0.0
+      zflubid(1:ngridmx)      = 0.0
+      zdtsurf(1:ngridmx)      = 0.0
+      dqsurf(1:ngridmx,1:nqmx)= 0.0
 
       zday=pday+ptime ! compute time, in sols (and fraction thereof)
@@ -610,13 +604,9 @@
 !     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-      do l=1,nlayer
-         do ig=1,ngrid
-            zzlay(ig,l)=pphi(ig,l)/g
-         enddo
-      enddo
-      do ig=1,ngrid
-         zzlev(ig,1)=0.
-         zzlev(ig,nlayer+1)=1.e7    ! dummy top of last layer above 10000 km...
-      enddo
+      zzlay(1:ngridmx,1:nlayermx)=pphi(1:ngridmx,1:nlayermx)/g
+
+      zzlev(1:ngridmx,1)=0.
+      zzlev(1:ngridmx,nlayer+1)=1.e7    ! dummy top of last layer above 10000 km...
+
       do l=2,nlayer
          do ig=1,ngrid
@@ -631,5 +621,4 @@
 !     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-
       do l=1,nlayer         
          do ig=1,ngrid 
@@ -657,5 +646,5 @@
               ztim3=-COS(declin)*SIN(2.*pi*(zday/year_day) - zls*nres)
 
-               call stelang(ngrid,sinlon,coslon,sinlat,coslat,    &
+              call stelang(ngrid,sinlon,coslon,sinlat,coslat,    &
                ztim1,ztim2,ztim3,mu0,fract)
 
@@ -707,5 +696,5 @@
                       zdtlw1,zdtsw1,fluxsurf_lw1,fluxsurf_sw1,fluxtop_lw1, &
                       fluxabs_sw1,fluxtop_dn,OLR_nu1,OSR_nu1,              &
-                      reffrad,tau_col1,cloudfrac,totcloudfrac,             &
+                      reffrad1,tau_col1,cloudfrac,totcloudfrac,             &
                       clearsky,firstcall,lastcall)
                  clearsky = .false.  ! just in case.     
@@ -722,15 +711,9 @@
                     tau_col(ig)     = ntf*tau_col1(ig)     + tf*tau_col(ig)
                     
-                    do l=1,nlayer
-                       zdtlw(ig,l) = ntf*zdtlw1(ig,l) + tf*zdtlw(ig,l)
-                       zdtsw(ig,l) = ntf*zdtsw1(ig,l) + tf*zdtsw(ig,l)
-                    enddo
-
-                    do nw=1,L_NSPECTV
-                       OSR_nu(ig,nw) = ntf*OSR_nu1(ig,nw) + tf*OSR_nu(ig,nw)		       
-                    enddo
-                    do nw=1,L_NSPECTI
-                       OLR_nu(ig,nw) = ntf*OLR_nu1(ig,nw) + tf*OLR_nu(ig,nw)		       
-                    enddo
+                    zdtlw(ig,1:nlayermx) = ntf*zdtlw1(ig,1:nlayermx) + tf*zdtlw(ig,1:nlayermx)
+                    zdtsw(ig,1:nlayermx) = ntf*zdtsw1(ig,1:nlayermx) + tf*zdtsw(ig,1:nlayermx)
+
+                    OSR_nu(ig,1:L_NSPECTV) = ntf*OSR_nu1(ig,1:L_NSPECTV) + tf*OSR_nu(ig,1:L_NSPECTV)		       
+                    OLR_nu(ig,1:L_NSPECTV) = ntf*OLR_nu1(ig,1:L_NSPECTV) + tf*OLR_nu(ig,1:L_NSPECTV)		       
 
                  enddo
@@ -740,25 +723,14 @@
 !             Radiative flux from the sky absorbed by the surface (W.m-2)
               GSR=0.0
-              do ig=1,ngrid
-                 fluxrad_sky(ig)=emis(ig)*fluxsurf_lw(ig)             &
-                      +fluxsurf_sw(ig)*(1.-albedo(ig))
-
-                 if(noradsurf)then ! no lower surface; SW flux just disappears
-                    GSR = GSR + fluxsurf_sw(ig)*area(ig)
-                    fluxrad_sky(ig)=emis(ig)*fluxsurf_lw(ig)
-                 endif
-
-              enddo
-              if(noradsurf)then
-                 print*,'SW lost in deep atmosphere = ',GSR/totarea,' W m^-2'
+              fluxrad_sky(1:ngridmx)=emis(1:ngridmx)*fluxsurf_lw(1:ngridmx)+fluxsurf_sw(1:ngridmx)*(1.-albedo(1:ngridmx))
+
+              if(noradsurf)then ! no lower surface; SW flux just disappears
+                 GSR = SUM(fluxsurf_sw(1:ngridmx)*area(1:ngridmx))/totarea
+                 fluxrad_sky(1:ngridmx)=emis(1:ngridmx)*fluxsurf_lw(1:ngridmx)
+                 print*,'SW lost in deep atmosphere = ',GSR,' W m^-2'
               endif
 
 !             Net atmospheric radiative heating rate (K.s-1)
-              do l=1,nlayer
-                 do ig=1,ngrid
-                    dtrad(ig,l)=zdtsw(ig,l)+zdtlw(ig,l)
-                 enddo
-              enddo
-
+              dtrad(1:ngridmx,1:nlayermx)=zdtsw(1:ngridmx,1:nlayermx)+zdtlw(1:ngridmx,1:nlayermx)
 
            elseif(newtonian)then
@@ -768,7 +740,5 @@
               call newtrelax(mu0,sinlat,zpopsk,pt,pplay,pplev,dtrad,firstcall)
 
-              do ig=1,ngrid
-                 zdtsurf(ig) = +(pt(ig,1)-tsurf(ig))/ptimestep
-              enddo
+              zdtsurf(1:ngridmx) = +(pt(1:ngridmx,1)-tsurf(1:ngridmx))/ptimestep
               ! e.g. surface becomes proxy for 1st atmospheric layer ?
 
@@ -777,19 +747,16 @@
 !          c) Atmosphere has no radiative effect
 !          ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-              do ig=1,ngrid
-                 fluxtop_dn(ig)  = fract(ig)*mu0(ig)*Fat1AU/dist_star**2
-                 if(ngrid.eq.1)then ! / by 4 globally in 1D case...
-                    fluxtop_dn(1)  = fract(1)*Fat1AU/dist_star**2/2.0
-                 endif
-                 fluxsurf_sw(ig) = fluxtop_dn(ig)
-                 fluxrad_sky(ig) = fluxtop_dn(ig)*(1.-albedo(ig))
-                 fluxtop_lw(ig)  = emis(ig)*sigma*tsurf(ig)**4
-              enddo ! radiation skips the atmosphere entirely
-
-              do l=1,nlayer
-                 do ig=1,ngrid
-                    dtrad(ig,l)=0.0
-                 enddo
-              enddo ! hence no atmospheric radiative heating
+              fluxtop_dn(1:ngridmx)  = fract(1:ngridmx)*mu0(1:ngridmx)*Fat1AU/dist_star**2
+              if(ngrid.eq.1)then ! / by 4 globally in 1D case...
+                 fluxtop_dn(1)  = fract(1)*Fat1AU/dist_star**2/2.0
+              endif
+              fluxsurf_sw(1:ngridmx) = fluxtop_dn(1:ngridmx)
+              fluxrad_sky(1:ngridmx) = fluxtop_dn(1:ngridmx)*(1.-albedo(1:ngridmx))
+              fluxtop_lw(1:ngridmx)  = emis(1:ngridmx)*sigma*tsurf(1:ngridmx)**4
+              ! radiation skips the atmosphere entirely
+
+
+              dtrad(1:ngridmx,1:nlayermx)=0.0
+              ! hence no atmospheric radiative heating
 
            endif                ! if corrk
@@ -801,15 +768,8 @@
 !    ------------------------------------------
 
-        do ig=1,ngrid
-           zplanck(ig)=tsurf(ig)*tsurf(ig)
-           zplanck(ig)=emis(ig)*sigma*zplanck(ig)*zplanck(ig)
-           fluxrad(ig)=fluxrad_sky(ig)-zplanck(ig)
-        enddo
-
-        do l=1,nlayer
-           do ig=1,ngrid
-              pdt(ig,l)=pdt(ig,l)+dtrad(ig,l)
-           enddo
-        enddo
+        zplanck(1:ngridmx)=tsurf(1:ngridmx)*tsurf(1:ngridmx)
+        zplanck(1:ngridmx)=emis(1:ngridmx)*sigma*zplanck(1:ngridmx)*zplanck(1:ngridmx)
+        fluxrad(1:ngridmx)=fluxrad_sky(1:ngridmx)-zplanck(1:ngridmx)
+        pdt(1:ngridmx,1:nlayermx)=pdt(1:ngridmx,1:nlayermx)+dtrad(1:ngridmx,1:nlayermx)
 
 !-------------------------
@@ -840,10 +800,8 @@
       if (calldifv) then
       
-         do ig=1,ngrid
-            zflubid(ig)=fluxrad(ig)+fluxgrd(ig)
-         enddo
-
-         zdum1(:,:)=0.0
-         zdum2(:,:)=0.0
+         zflubid(1:ngridmx)=fluxrad(1:ngridmx)+fluxgrd(1:ngridmx)
+
+         zdum1(1:ngridmx,1:nlayermx)=0.0
+         zdum2(1:ngridmx,1:nlayermx)=0.0
 
 
@@ -857,13 +815,9 @@
               zdum1,zdum2,pdt,pdq,zflubid,           &
               zdudif,zdvdif,zdtdif,zdtsdif,          &
-	      sensibFlux,q2,zdqdif,zdqsdif,lastcall)
+	      sensibFlux,q2,zdqdif,zdqevap,zdqsdif,lastcall)
 
 	 else
 	 
-           do l=1,nlayer
-             do ig=1,ngrid 
-               zdh(ig,l)=pdt(ig,l)/zpopsk(ig,l)
-             enddo
-           enddo
+           zdh(1:ngridmx,1:nlayermx)=pdt(1:ngridmx,1:nlayermx)/zpopsk(1:ngridmx,1:nlayermx)
  
            call vdifc(ngrid,nlayer,nq,rnat,zpopsk,   &
@@ -875,38 +829,16 @@
 	      sensibFlux,q2,zdqdif,zdqsdif,lastcall)
 
-           do l=1,nlayer
-             do ig=1,ngrid
-                zdtdif(ig,l)=zdhdif(ig,l)*zpopsk(ig,l) ! for diagnostic only
-             enddo
-           enddo
+           zdtdif(1:ngridmx,1:nlayermx)=zdhdif(1:ngridmx,1:nlayermx)*zpopsk(1:ngridmx,1:nlayermx) ! for diagnostic only
+	   zdqevap(1:ngridmx,1:nlayermx)=0.
 
          end if !turbdiff
 
-         do l=1,nlayer
-            do ig=1,ngrid
-               pdv(ig,l)=pdv(ig,l)+zdvdif(ig,l)
-               pdu(ig,l)=pdu(ig,l)+zdudif(ig,l)
-               pdt(ig,l)=pdt(ig,l)+zdtdif(ig,l)
-            enddo
-         enddo
-
-         do ig=1,ngrid
-            zdtsurf(ig)=zdtsurf(ig)+zdtsdif(ig)
-         enddo
-
+         pdv(1:ngridmx,1:nlayermx)=pdv(1:ngridmx,1:nlayermx)+zdvdif(1:ngridmx,1:nlayermx)
+         pdu(1:ngridmx,1:nlayermx)=pdu(1:ngridmx,1:nlayermx)+zdudif(1:ngridmx,1:nlayermx)
+         pdt(1:ngridmx,1:nlayermx)=pdt(1:ngridmx,1:nlayermx)+zdtdif(1:ngridmx,1:nlayermx)
+         zdtsurf(1:ngridmx)=zdtsurf(1:ngridmx)+zdtsdif(1:ngridmx)
          if (tracer) then 
-           do iq=1, nq
-            do l=1,nlayer
-              do ig=1,ngrid
-                 pdq(ig,l,iq)=pdq(ig,l,iq)+ zdqdif(ig,l,iq) 
-              enddo
-            enddo
-           enddo
-           do iq=1, nq
-              do ig=1,ngrid
-                 dqsurf(ig,iq)=dqsurf(ig,iq) + zdqsdif(ig,iq)
-              enddo
-           enddo
-
+           pdq(1:ngridmx,1:nlayermx,1:nqmx)=pdq(1:ngridmx,1:nlayermx,1:nqmx)+ zdqdif(1:ngridmx,1:nlayermx,1:nqmx) 
+           dqsurf(1:ngridmx,1:nqmx)=dqsurf(1:ngridmx,1:nqmx) + zdqsdif(1:ngridmx,1:nqmx)
          end if ! of if (tracer)
 
@@ -965,7 +897,5 @@
          if(.not.newtonian)then
 
-            do ig=1,ngrid
-               zdtsurf(ig) = zdtsurf(ig) + (fluxrad(ig) + fluxgrd(ig))/capcal(ig)
-            enddo
+            zdtsurf(1:ngridmx) = zdtsurf(1:ngridmx) + (fluxrad(1:ngridmx) + fluxgrd(1:ngridmx))/capcal(1:ngridmx)
 
          endif
@@ -980,12 +910,8 @@
       if(calladj) then
 
-         do l=1,nlayer
-            do ig=1,ngrid
-               zdh(ig,l) = pdt(ig,l)/zpopsk(ig,l)
-            enddo
-         enddo
-         zduadj(:,:)=0.0
-         zdvadj(:,:)=0.0
-         zdhadj(:,:)=0.0
+         zdh(1:ngridmx,1:nlayermx) = pdt(1:ngridmx,1:nlayermx)/zpopsk(1:ngridmx,1:nlayermx)
+         zduadj(1:ngridmx,1:nlayermx)=0.0
+         zdvadj(1:ngridmx,1:nlayermx)=0.0
+         zdhadj(1:ngridmx,1:nlayermx)=0.0
 
 
@@ -997,21 +923,11 @@
               zdqadj)
 
-         do l=1,nlayer
-            do ig=1,ngrid
-               pdu(ig,l) = pdu(ig,l) + zduadj(ig,l)
-               pdv(ig,l) = pdv(ig,l) + zdvadj(ig,l)
-               pdt(ig,l)    = pdt(ig,l) + zdhadj(ig,l)*zpopsk(ig,l)
-               zdtadj(ig,l) = zdhadj(ig,l)*zpopsk(ig,l) ! for diagnostic only
-            enddo
-         enddo
-
+         pdu(1:ngridmx,1:nlayermx) = pdu(1:ngridmx,1:nlayermx) + zduadj(1:ngridmx,1:nlayermx)
+         pdv(1:ngridmx,1:nlayermx) = pdv(1:ngridmx,1:nlayermx) + zdvadj(1:ngridmx,1:nlayermx)
+         pdt(1:ngridmx,1:nlayermx)    = pdt(1:ngridmx,1:nlayermx) + zdhadj(1:ngridmx,1:nlayermx)*zpopsk(1:ngridmx,1:nlayermx)
+         zdtadj(1:ngridmx,1:nlayermx) = zdhadj(1:ngridmx,1:nlayermx)*zpopsk(1:ngridmx,1:nlayermx) ! for diagnostic only
+ 
          if(tracer) then 
-           do iq=1, nq
-            do l=1,nlayer
-              do ig=1,ngrid
-                 pdq(ig,l,iq) = pdq(ig,l,iq) + zdqadj(ig,l,iq) 
-              enddo
-            enddo
-           enddo
+            pdq(1:ngridmx,1:nlayermx,1:nqmx) = pdq(1:ngridmx,1:nlayermx,1:nqmx) + zdqadj(1:ngridmx,1:nlayermx,1:nqmx) 
          end if
 
@@ -1061,22 +977,11 @@
               zdqc,reffrad)
 
-         do l=1,nlayer
-           do ig=1,ngrid
-             pdt(ig,l)=pdt(ig,l)+zdtc(ig,l)
-             pdv(ig,l)=pdv(ig,l)+zdvc(ig,l)
-             pdu(ig,l)=pdu(ig,l)+zduc(ig,l)
-           enddo
-         enddo
-         do ig=1,ngrid
-            zdtsurf(ig) = zdtsurf(ig) + zdtsurfc(ig)
-         enddo
-
-         do iq=1,nq ! should use new notation here !
-            do l=1,nlayer
-               do ig=1,ngrid
-                  pdq(ig,l,iq)=pdq(ig,l,iq)+ zdqc(ig,l,iq) 
-               enddo
-            enddo
-         enddo
+
+         pdt(1:ngridmx,1:nlayermx)=pdt(1:ngridmx,1:nlayermx)+zdtc(1:ngridmx,1:nlayermx)
+         pdv(1:ngridmx,1:nlayermx)=pdv(1:ngridmx,1:nlayermx)+zdvc(1:ngridmx,1:nlayermx)
+         pdu(1:ngridmx,1:nlayermx)=pdu(1:ngridmx,1:nlayermx)+zduc(1:ngridmx,1:nlayermx)
+         zdtsurf(1:ngridmx) = zdtsurf(1:ngridmx) + zdtsurfc(1:ngridmx)
+
+         pdq(1:ngridmx,1:nlayermx,1:nqmx)=pdq(1:ngridmx,1:nlayermx,1:nqmx)+ zdqc(1:ngridmx,1:nlayermx,1:nqmx) 
          ! Note: we do not add surface co2ice tendency
          ! because qsurf(:,igcm_co2_ice) is updated in condens_co2cloud
@@ -1108,35 +1013,44 @@
 !        Water ice condensation in the atmosphere
 !        ----------------------------------------
-            if(watercond)then
-
-	       if(RLVTT.gt.1.e-8)then
-
+            if(watercond.and.(RLVTT.gt.1.e-8))then
+
+!             ----------------
+!             Moist convection
+!             ----------------
                ! Re-evaporate cloud water/ice
-               call evap(ptimestep,pt,pq,pdq,pdt,dqevap,dtevap,qevap,tevap)
-               DO l = 1, nlayer  
-                  DO ig = 1, ngrid 
-                     pdq(ig,l,igcm_h2o_vap) = pdq(ig,l,igcm_h2o_vap)+dqevap(ig,l)
-                     pdq(ig,l,igcm_h2o_ice) = pdq(ig,l,igcm_h2o_ice)-dqevap(ig,l)
-                     pdt(ig,l)              = pdt(ig,l)+dtevap(ig,l)
-                  enddo
-               enddo
-
-               call moistadj(pt,qevap,pplev,pplay,dtmoist,dqmoist,ptimestep,rneb_man)
-               do l=1,nlayer
-                  do ig=1,ngrid
-                     pdq(ig,l,igcm_h2o_vap) = pdq(ig,l,igcm_h2o_vap)+dqmoist(ig,l,igcm_h2o_vap)
-                     pdq(ig,l,igcm_h2o_ice) = pdq(ig,l,igcm_h2o_ice)+dqmoist(ig,l,igcm_h2o_ice)
-                     pdt(ig,l)              = pdt(ig,l)+dtmoist(ig,l)
-                  enddo
-               enddo
+!	       dqevap1(1:ngridmx,1:nlayermx)=0.
+!	       dtevap1(1:ngridmx,1:nlayermx)=0.
+!               call evap(ptimestep,pt,pq,pdq,pdt,dqevap1,dtevap1,qevap,tevap)
+               
+	       dqmoist(1:ngridmx,1:nlayermx,1:nqmx)=0.
+	       dtmoist(1:ngridmx,1:nlayermx)=0.
+
+               call moistadj(pt,pq,pdq,pplev,pplay,dtmoist,dqmoist,ptimestep,rneb_man)
+
+               pdq(1:ngridmx,1:nlayermx,igcm_h2o_vap) = pdq(1:ngridmx,1:nlayermx,igcm_h2o_vap)   &
+	                  +dqmoist(1:ngridmx,1:nlayermx,igcm_h2o_vap)
+               pdq(1:ngridmx,1:nlayermx,igcm_h2o_ice) =pdq(1:ngridmx,1:nlayermx,igcm_h2o_ice)     &
+                          +dqmoist(1:ngridmx,1:nlayermx,igcm_h2o_ice)
+               pdt(1:ngridmx,1:nlayermx) = pdt(1:ngridmx,1:nlayermx)+dtmoist(1:ngridmx,1:nlayermx)
+
+!               do l=1,nlayermx
+!	         do ig=1,ngridmx
+!	          if(isnan(dqmoist(ig,l,igcm_h2o_ice))) print*,'Nan in dqmoist ice, abort,ig,l',ig,l
+!	          if(isnan(dqmoist(ig,l,igcm_h2o_vap))) print*,'Nan in dqmoist vap, abort,ig,l',ig,l
+!	          if(isnan(dtmoist(ig,l))) print*,'Nan in dtmoist, abort,ig,l',ig,l		  
+!                  if(isnan(dqmoist(ig,l,igcm_h2o_ice)).or.isnan(dqmoist(ig,l,igcm_h2o_vap)).or.isnan(dtmoist(ig,l))) STOP
+!	         enddo
+!	       enddo
+!	       print*,'after moist',dqmoist(185,1,igcm_h2o_ice),dqmoist(185,1,igcm_h2o_vap),dtmoist(185,1)*86400.
 
                !-------------------------
                ! test energy conservation
                if(enertest)then
-                  dEtot=cpp*SUM(massarea(:,:)*(dtmoist(:,:)+dtevap(:,:)))/totarea
+                  dEtot=cpp*SUM(massarea(:,:)*dtmoist(:,:))/totarea
                   do ig = 1, ngrid
-                     madjdE(ig) = cpp*SUM(mass(:,:)*(dtmoist(:,:)+dtevap(:,:)))
+                     madjdE(ig) = cpp*SUM(mass(:,:)*dtmoist(:,:))
                   enddo
                   print*,'In moistadj atmospheric energy change   =',dEtot,' W m-2'
+                  print*,'In moistadj MAX atmospheric energy change   =',MAXVAL(pdt(:,:))*86400.,'K/day'
 		  
 		! test energy conservation
@@ -1146,48 +1060,33 @@
                endif
                !-------------------------
-               
-
-	       endif
 	       
 
-               ! Re-evaporate cloud water/ice
-               call evap(ptimestep,pt,pq,pdq,pdt,dqevap,dtevap,qevap,tevap)
-               do l = 1, nlayer  
-                  do ig = 1, ngrid
-                     pdq(ig,l,igcm_h2o_vap) = pdq(ig,l,igcm_h2o_vap)+dqevap(ig,l)
-                     pdq(ig,l,igcm_h2o_ice) = pdq(ig,l,igcm_h2o_ice)-dqevap(ig,l)
-                     pdt(ig,l)              = pdt(ig,l)+dtevap(ig,l)
-                  enddo
-               enddo ! note: we use qevap but not tevap in largescale/moistadj
-                     ! otherwise is a big mess
-
-               call largescale(ptimestep,pplev,pplay,pt,qevap,        & ! a bug was here!
-                    pdt,dtlscale,dqvaplscale,dqcldlscale,rneb_lsc,reffH2O)
-               do l=1,nlayer
-                  do ig=1,ngrid
-                     pdq(ig,l,igcm_h2o_vap) = pdq(ig,l,igcm_h2o_vap)+dqvaplscale(ig,l)
-                     pdq(ig,l,igcm_h2o_ice) = pdq(ig,l,igcm_h2o_ice)+dqcldlscale(ig,l)
-                     pdt(ig,l)              = pdt(ig,l)+dtlscale(ig,l)
-                     
-                     if(aeroh2o.and.(.not.aerofixh2o)) then
-                        reffrad(ig,l,iaero_h2o)=reffH2O(ig,l)
-                     endif
-
-                  enddo
-               enddo
+!        --------------------------------
+!        Large scale condensation/evaporation
+!        --------------------------------
+
+               call largescale(ptimestep,pplev,pplay,pt,pq,pdt,pdq,dtlscale,dqvaplscale,dqcldlscale,rneb_lsc)
+
+               pdt(1:ngridmx,1:nlayermx) = pdt(1:ngridmx,1:nlayermx)+dtlscale(1:ngridmx,1:nlayermx)
+               pdq(1:ngridmx,1:nlayermx,igcm_h2o_vap) = pdq(1:ngridmx,1:nlayermx,igcm_h2o_vap)+dqvaplscale(1:ngridmx,1:nlayermx)
+               pdq(1:ngridmx,1:nlayermx,igcm_h2o_ice) = pdq(1:ngridmx,1:nlayermx,igcm_h2o_ice)+dqcldlscale(1:ngridmx,1:nlayermx)
 
                !-------------------------
                ! test energy conservation
                if(enertest)then
-                  dEtot=cpp*SUM(massarea(:,:)*(dtmoist(:,:)+dtevap(:,:)))/totarea
                   do ig = 1, ngrid
-                     madjdE(ig) = cpp*SUM(mass(:,:)*(dtmoist(:,:)+dtevap(:,:)))
+                     lscaledE(ig) = cpp*SUM(mass(:,:)*dtlscale(:,:))
                   enddo
-                  print*,'In moistadj atmospheric energy change   =',dEtot,' W m-2'
-		  
-		! test energy conservation
-	          dWtot = SUM(massarea(:,:)*dqmoist(:,:,igcm_h2o_vap))*ptimestep/totarea
-                  dWtot = dWtot + SUM(massarea(:,:)*dqmoist(:,:,igcm_h2o_ice))*ptimestep/totarea
-                  print*,'In moistadj atmospheric water change    =',dWtot,' kg m-2'
+                  dEtot=cpp*SUM(massarea(:,:)*(dtlscale(:,:)))/totarea
+		  if(isnan(dEtot)) then
+		     print*,'Nan in largescale, abort'
+                     STOP
+		  endif
+		  print*,'In largescale atmospheric energy change =',dEtot,' W m-2'
+
+               ! test water conservation
+	          dWtot = SUM(massarea(:,:)*dqvaplscale(:,:))*ptimestep/totarea
+                  dWtot = dWtot + SUM(massarea(:,:)*dqcldlscale(:,:))*ptimestep/totarea
+                  print*,'In largescale atmospheric water change  =',dWtot,' kg m-2'
                endif
                !-------------------------
@@ -1200,8 +1099,5 @@
                enddo
 
-               ! compute total cloud fraction in column
-               call totalcloudfrac(cloudfrac,totcloudfrac)
-
-           endif                ! of if (watercondense)
+            endif                ! of if (watercondense)
            
 
@@ -1209,27 +1105,21 @@
 !        Water ice / liquid precipitation
 !        --------------------------------
-           if(waterrain)then
-
-              zdqrain(:,:,:) = 0.0
-              zdqsrain(:)    = 0.0
-              zdqssnow(:)    = 0.0
-
-              call rain(ptimestep,pplev,pplay,pt,pdt,pq,pdq,            &
+            if(waterrain)then
+
+               zdqrain(1:ngridmx,1:nlayermx,1:nqmx) = 0.0
+               zdqsrain(1:ngridmx)    = 0.0
+               zdqssnow(1:ngridmx)    = 0.0
+
+               call rain(ptimestep,pplev,pplay,pt,pdt,pq,pdq,            &
                    zdtrain,zdqrain,zdqsrain,zdqssnow,cloudfrac)
 
-              do l=1,nlayer
-                 do ig=1,ngrid
-                    pdq(ig,l,igcm_h2o_vap) = pdq(ig,l,igcm_h2o_vap)+zdqrain(ig,l,igcm_h2o_vap)
-                    pdq(ig,l,igcm_h2o_ice) = pdq(ig,l,igcm_h2o_ice)+zdqrain(ig,l,igcm_h2o_ice)
-                    pdt(ig,l)              = pdt(ig,l)+zdtrain(ig,l)
-                 enddo
-              enddo
-
-              do ig=1,ngrid
-                 dqsurf(ig,igcm_h2o_vap) = dqsurf(ig,igcm_h2o_vap)+zdqsrain(ig) ! a bug was here
-                 dqsurf(ig,igcm_h2o_ice) = dqsurf(ig,igcm_h2o_ice)+zdqssnow(ig)
-                 rainout(ig)             = zdqsrain(ig)+zdqssnow(ig) ! diagnostic   
-              enddo
-
+               pdq(1:ngridmx,1:nlayermx,igcm_h2o_vap) = pdq(1:ngridmx,1:nlayermx,igcm_h2o_vap) &
+	             +zdqrain(1:ngridmx,1:nlayermx,igcm_h2o_vap)
+               pdq(1:ngridmx,1:nlayermx,igcm_h2o_ice) = pdq(1:ngridmx,1:nlayermx,igcm_h2o_ice) &
+	             +zdqrain(1:ngridmx,1:nlayermx,igcm_h2o_ice)
+               pdt(1:ngridmx,1:nlayermx) = pdt(1:ngridmx,1:nlayermx)+zdtrain(1:ngridmx,1:nlayermx)
+               dqsurf(1:ngridmx,igcm_h2o_vap) = dqsurf(1:ngridmx,igcm_h2o_vap)+zdqsrain(1:ngridmx) ! a bug was here
+               dqsurf(1:ngridmx,igcm_h2o_ice) = dqsurf(1:ngridmx,igcm_h2o_ice)+zdqssnow(1:ngridmx)
+               rainout(1:ngridmx)             = zdqsrain(1:ngridmx)+zdqssnow(1:ngridmx) ! diagnostic   
 
 
@@ -1242,5 +1132,5 @@
 		  dItot = dItot + SUM(area(:)*zdqssnow(:))/totarea*RLVTT/cpp
                   dVtot = SUM(massarea(:,:)*zdqrain(:,:,igcm_h2o_vap))*ptimestep/totarea
-		  dVtot = dItot + SUM(area(:)*zdqsrain(:))/totarea*RLVTT/cpp
+		  dVtot = dVtot + SUM(area(:)*zdqsrain(:))/totarea*RLVTT/cpp
 		  dEtot = dItot + dVtot
                  print*,'In rain dItot =',dItot,' W m-2'
@@ -1258,6 +1148,6 @@
               !-------------------------
 
-           end if                 ! of if (waterrain)
-        end if                    ! of if (water)
+            end if                 ! of if (waterrain)
+         end if                    ! of if (water)
 
 
@@ -1268,6 +1158,6 @@
 !        ------------- 
         if (sedimentation) then 
-           zdqsed(:,:,:) = 0.0
-           zdqssed(:,:)  = 0.0
+           zdqsed(1:ngridmx,1:nlayermx,1:nqmx) = 0.0
+           zdqssed(1:ngridmx,1:nqmx)  = 0.0
 
 
@@ -1297,15 +1187,9 @@
            !-------------------------
 
-           do iq=1,nq
-              ! for now, we only allow H2O ice to sediment
+           ! for now, we only allow H2O ice to sediment
               ! and as in rain.F90, whether it falls as rain or snow depends
               ! only on the surface temperature
-              do ig=1,ngrid
-                 do l=1,nlayer
-                    pdq(ig,l,iq) = pdq(ig,l,iq) + zdqsed(ig,l,iq)
-                 enddo
-                 dqsurf(ig,iq) = dqsurf(ig,iq) + zdqssed(ig,iq)
-              enddo
-           enddo
+           pdq(1:ngridmx,1:nlayermx,1:nqmx) = pdq(1:ngridmx,1:nlayermx,1:nqmx) + zdqsed(1:ngridmx,1:nlayermx,1:nqmx)
+           dqsurf(1:ngridmx,1:nqmx) = dqsurf(1:ngridmx,1:nqmx) + zdqssed(1:ngridmx,1:nqmx)
 
            !-------------------------
@@ -1326,4 +1210,39 @@
 !     ---------
 
+!       -----------------------------------
+!       Updating atm mass and tracer budget
+!       -----------------------------------
+
+         if(mass_redistrib) then
+
+            zdmassmr(1:ngridmx,1:nlayermx) = mass(1:ngridmx,1:nlayermx) * &
+	       (   zdqevap(1:ngridmx,1:nlayermx)                          &
+	         + zdqrain(1:ngridmx,1:nlayermx,igcm_h2o_vap)             &
+		 + dqmoist(1:ngridmx,1:nlayermx,igcm_h2o_vap)             &
+		 + dqvaplscale(1:ngridmx,1:nlayermx) )
+		 
+            
+	    call writediagfi(ngridmx,"mass_evap","mass gain"," ",3,zdmassmr)
+	    call writediagfi(ngridmx,"mass","mass"," ",3,mass)
+
+	    call mass_redistribution(ngrid,nlayer,nq,ptimestep,   &
+                       rnat,capcal,pplay,pplev,pt,tsurf,pq,qsurf,     &
+		       pu,pv,pdt,zdtsurf,pdq,pdu,pdv,zdmassmr,  &
+		       zdtmr,zdtsurfmr,zdpsrfmr,zdumr,zdvmr,zdqmr,zdqsurfmr)
+	 
+
+            pdq(1:ngridmx,1:nlayermx,1:nqmx) = pdq(1:ngridmx,1:nlayermx,1:nqmx) + zdqmr(1:ngridmx,1:nlayermx,1:nqmx)
+            dqsurf(1:ngridmx,1:nqmx)         = dqsurf(1:ngridmx,1:nqmx) + zdqsurfmr(1:ngridmx,1:nqmx)
+            pdt(1:ngridmx,1:nlayermx)        = pdt(1:ngridmx,1:nlayermx) + zdtmr(1:ngridmx,1:nlayermx)
+            pdu(1:ngridmx,1:nlayermx)        = pdu(1:ngridmx,1:nlayermx) + zdumr(1:ngridmx,1:nlayermx)
+            pdv(1:ngridmx,1:nlayermx)        = pdv(1:ngridmx,1:nlayermx) + zdvmr(1:ngridmx,1:nlayermx)
+	    pdpsrf(1:ngridmx)                = pdpsrf(1:ngridmx) + zdpsrfmr(1:ngridmx)
+            zdtsurf(1:ngridmx)               = zdtsurf(1:ngridmx) + zdtsurfmr(1:ngridmx)
+	    
+!	    print*,'after mass redistrib, q=',pq(211,1:nlayermx,igcm_h2o_vap)+ptimestep*pdq(211,1:nlayermx,igcm_h2o_vap) 
+	 endif
+
+
+
 !       ---------------------------------
 !       Updating tracer budget on surface
